<template>
  <div class="sw-gs-offcanvas-collection-product">
    <div v-on:click="!isSelfService ? openQuickViewModal() : null">
      <SwPluginSlot name="gs-offcanvas-collection-product" :slot-context="product">
        <SfProductCard
          :title="name"
          :image="imageUrl"
          :special-price="formatPrice(specialPrice)"
          :regular-price="formatPrice(regularPrice)"
          :image-width="'100%'"
          :image-height="'100%'"
          class="sw-product-card"
          :show-add-to-cart-button="true"
          @click="isSelfService ? openDynamicPage({
            type: 'product',
            opened: true,
            productId: productId
          }) : null"
        >
          <template #wishlist-icon>
            <template v-if="isClient || (isGuide && currentClientForGuide && allowUserActionsForGuide)">
              <SwButton class="sw-gs-product-card-like-btn color-light is-circle"
                        :class="{'is-on-list': productLiked}"
                        :title="$t('Like')"
                        :disabled="likeLoading"
                        @click.stop="likeHandler">
                <SfLoader :loading="likeLoading">
                  <SwGsIconThumbsUpSmall class="sw-gs-product-card-like-icon color-dark-secondary size-sm"/>
                </SfLoader>
              </SwButton>
            </template>
            <template v-else><span></span></template>
          </template>

          <template #add-to-cart="{
            title,
          }">
            <template v-if="isClient || (isGuide && currentClientCartPermissions)">
              <SwGsAddToCartBtn
                :title="title"
                :product="product"
              />
            </template>
            <span v-else></span>
          </template>
        </SfProductCard>
      </SwPluginSlot>
    </div>

    <div class="sw-gs-cms-element-actions sw-gs-nav-overlay" v-if="isGuide && !isSelfService">
      <SwButton class="sw-gs-got-to-pdp-btn color-light is-circle"
                @click="openDynamicPage({
                  type: 'product',
                  opened: true,
                  productId: productId
                })"
                :title="$t('Go to product detail page')">
        <SwGsIconLongArrowRight class="dark-secondary size-sm"/>
      </SwButton>
    </div>
  </div>
</template>

<script lang="ts">
  import { SfProductCard, SfLoader } from "@storefront-ui/vue"
  import SwButton from "@/components/atoms/SwButton.vue";
  import {
    getProductThumbnailUrl,
    getProductTierPrices,
    getProductName,
    getProductCalculatedPrice,
    getProductCalculatedListingPrice,
    getProductPriceDiscount,
  } from "@shopware-pwa/helpers"
  import getResizedImage from "@/helpers/images/getResizedImage.js"
  import { computed, ref, toRefs } from "@vue/composition-api"
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue"
  import { SwGsIconThumbsUpSmall, SwGsIconLongArrowRight } from "../icons";
  import SwGsAddToCartBtn from "../SwGsAddToCartBtn.vue";
  import { usePriceFilter } from "../../logic/composables/usePriceFilter";
  import { useState } from "../../logic/composables/useState";
  import { useDynamicPage } from "../../logic/composables/useDynamicPage";
  import { useLikeList } from "../../logic/composables/useLikeList";
  import { useAppointment } from "../../logic/composables/useAppointment";
  import { useGsCart } from "../../logic/composables/useGsCart";
  import { useQuickView } from "../../logic/composables/useQuickView";

  export default {
    name: "SwGsOffcanvasCollectionProduct",
    components: {
      SfLoader,
      SfProductCard,
      SwButton,
      SwPluginSlot,
      SwGsIconThumbsUpSmall,
      SwGsIconLongArrowRight,
      SwGsAddToCartBtn
    },
    props: {
      product: {
        type: Object,
        default: () => ({}),
      },
    },
    setup(props, {}) {
      const { product } = toRefs(props);
      const { currentClientCartPermissions } = useGsCart()
      const name = computed(() => getProductName({product: product.value}));
      const {currentClientForGuide, stateForAll} = useState();
      const {isGuide, isClient, isSelfService} = useAppointment();
      const {openDynamicPage} = useDynamicPage();
      const {openQuickView} = useQuickView();
      const { formatPrice } = usePriceFilter();

      const imageUrl = computed(() =>
        getResizedImage(getProductThumbnailUrl(product.value), {
          width: 180,
          height: 200,
          quality: 100
        })
      )

      const tierPrices = computed(() =>
        getProductTierPrices(product.value)
      )

      const specialPrice = computed(() =>
        tierPrices.value.length
          ? undefined
          : getProductPriceDiscount(product.value) &&
          getProductCalculatedPrice(product.value)
      )

      const regularPrice = computed(() =>
        (tierPrices.value.length &&
          tierPrices.value[0] &&
          tierPrices.value[0].unitPrice) ||
        getProductCalculatedListingPrice(product.value)
      )

      const { like, removeFromLikeList, productLiked } = useLikeList(product.value);
      const likeLoading = ref(false);

      function likeHandler() {
        likeLoading.value = true;
        if (productLiked.value === true ) {
          removeFromLikeList();
        } else {
          like();
        }
        likeLoading.value = false;
      }

      function openQuickViewModal() {
        openQuickView(product.value);
      }

      return {
        currentClientCartPermissions,
        name,
        imageUrl,
        tierPrices,
        specialPrice,
        regularPrice,
        formatPrice,
        currentClientForGuide,
        likeHandler,
        productLiked,
        likeLoading,
        isGuide,
        isClient,
        isSelfService,
        productId: computed(() => product.value.id),
        openDynamicPage,
        openQuickViewModal,
        allowUserActionsForGuide: computed(() => stateForAll.value?.allowUserActionsForGuide)
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-product-card {
    width: 100%;
    padding: var(--spacer-2xs);

    &:hover {
      @include for-desktop {
        .sw-gs-product-card-like-btn {
          opacity: 1;
        }
      }
    }
  }

  .sw-gs-product-card-like-btn {
    opacity: 1;

    @include for-desktop {
      opacity: 0;
      transition: opacity .4s ease-in-out 0s;
    }

    &.is-on-list {
      opacity: 1;

      .sw-gs-product-card-like-icon {
        --icon-color: var(--c-success);
      }
    }
  }

  ::v-deep {
    .sf-product-card__image-wrapper {
      min-height: 120px;
    }

    .sf-product-card__wishlist-icon {
      display: block;
      top: var(--spacer-2xs);
      right: var(--spacer-2xs);
      opacity: 1; // moved transition onto buttons themselves
      transition: none;
    }

    .sf-loader {
      width: 22px;
      height: 22px;
    }

    .sf-loader__overlay {
      background: none;
    }
  }

  .sw-gs-offcanvas-collection-product {
    position: relative;

    &:hover {
      & > .sw-gs-cms-element-actions {
        display: flex;
      }
    }
  }

  .sw-gs-cms-element-actions {
    position: absolute;
    left: 0;
    top: 0;
    z-index: var(--helper-lay-over-sibling-z-index);
    display: none;
  }
</style>
